#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

int n,a,b,q;
vector<int> v[MAXN];
int in[MAXN],sz[MAXN];

void dfs(int x,int p){
    sz[x]=1;
    for(int i=0;i<v[x].size();i++){
        dfs(v[x][i],x);
        sz[x]+=sz[v[x][i]];
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    cin>>n;
    for(int i=1;i<=n-1;i++){
        cin>>a>>b;
        v[a].push_back(b);
        in[b]++;
    }

    for(int i=1;i<=n;i++){
        if(in[i]==0)dfs(i,0);
    }

    cin>>q;
    for(int i=1;i<=q;i++){
        cin>>a;
        cout<<sz[a]-1<<"\n";
    }


    return 0;
}
